'use strict';

import Adw from 'gi://Adw';

import Gio from 'gi://Gio';
import Gtk from 'gi://Gtk';


import {ExtensionPreferences, gettext as _} from 'resource:///org/gnome/Shell/Extensions/js/extensions/prefs.js';


/*
var SlideShowPage = GObject.registerClass(
    class PreferencesPage extends Adw.PreferencesPage {
        _init(settings) {
            super._init({
                title: _('Slideshow'),
                icon_name: 'emblem-photos-symbolic',
                name: 'HomePage',
            });
    
            this._settings = settings;
            this._backgroundSettings = new Gio.Settings({schema: 'org.gnome.desktop.background'});
    
            const slideShowGroup = new Adw.PreferencesGroup({
                title: _('Slideshow Options'),
            });
            this.add(slideShowGroup);
    
            const slideShowDirRow = new Adw.ActionRow({
                title: _('Slideshow Directory'),
                subtitle: this._settings.get_string('slideshow-directory'),
            });
            const fileChooserButton = createFileChooserButton(this, this._settings, 'slideshow-directory', slideShowDirRow);
            const openDirectoryButton = createOpenDirectoyButton(this, this._settings.get_string('slideshow-directory'));
            slideShowDirRow.add_prefix(openDirectoryButton);
            slideShowDirRow.add_suffix(fileChooserButton);
            slideShowGroup.add(slideShowDirRow);
    
            const slideDurationRow = new Adw.ActionRow({
                title: _('Slide Duration'),
                subtitle: `${_('Hours')}:${_('Minutes')}:${_('Seconds')}`,
            });
            slideShowGroup.add(slideDurationRow);
    
            const updateSlideDuration = () => {
                if (this._updateTimeoutId)
                    GLib.source_remove(this._updateTimeoutId);
    
                const hours = hoursSpinButton.get_value();
                const minutes = minutesSpinButton.get_value();
                const seconds = secondsSpinButton.get_value();
    
                this._updateTimeoutId = GLib.timeout_add(GLib.PRIORITY_DEFAULT, 500, () => {
                    this._settings.set_value('slideshow-slide-duration', new GLib.Variant('(iii)', [hours, minutes, seconds]));
                    this._updateTimeoutId = null;
                    return GLib.SOURCE_REMOVE;
                });
            };
    
            const slideDurationGrid = new Gtk.Grid({
                row_spacing: 2,
                column_spacing: 4,
            });
            slideDurationRow.add_suffix(slideDurationGrid);
    
            const [hours, minutes, seconds] = this._settings.get_value('slideshow-slide-duration').deep_unpack();
            const hoursSpinButton = this._createSpinButton(hours, 0, 24);
            hoursSpinButton.connect('value-changed', () => {
                updateSlideDuration();
            });
            const hoursLabel = new Gtk.Label({
                label: '∶',
                css_classes: ['title-3'],
                halign: Gtk.Align.START,
            });
    
            const minutesSpinButton = this._createSpinButton(minutes, 0, 60);
            minutesSpinButton.connect('value-changed', () => {
                updateSlideDuration();
            });
            const minutesLabel = new Gtk.Label({
                label: '∶',
                css_classes: ['title-3'],
                halign: Gtk.Align.START,
            });
    
            const secondsSpinButton = this._createSpinButton(seconds, 0, 60);
            secondsSpinButton.connect('value-changed', () => {
                updateSlideDuration();
            });
    
            slideDurationGrid.attach(hoursSpinButton, 0, 0, 1, 1);
            slideDurationGrid.attach(hoursLabel, 1, 0, 1, 1);
            slideDurationGrid.attach(minutesSpinButton, 2, 0, 1, 1);
            slideDurationGrid.attach(minutesLabel, 3, 0, 1, 1);
            slideDurationGrid.attach(secondsSpinButton, 4, 0, 1, 1);
    
            const slideDurationTypeRow = new Adw.SwitchRow({
                title: _('Use Absolute Time for Slide Duration'),
                subtitle: _('The slide duration will be based on absolute time elapsed, rather than time the image is displayed on the screen. Changing this setting will reset any current slide durations.'),
                active: this._settings.get_boolean('slideshow-use-absolute-time-for-duration'),
            });
            slideDurationTypeRow.connect('notify::active', widget => {
                this._settings.set_boolean('slideshow-use-absolute-time-for-duration', widget.get_active());
            });
            slideShowGroup.add(slideDurationTypeRow);
    
            const backgroundGroup = new Adw.PreferencesGroup({
                title: _('Wallpaper Options'),
            });
            this.add(backgroundGroup);
    
            const adjustmentList = new Gtk.StringList();
            adjustmentList.append(_('None'));
            adjustmentList.append(_('Wallpaper'));
            adjustmentList.append(_('Centered'));
            adjustmentList.append(_('Scaled'));
            adjustmentList.append(_('Streched'));
            adjustmentList.append(_('Zoom'));
            adjustmentList.append(_('Spanned'));
    
            const backgroundAdjustRow = new Adw.ComboRow({
                title: _('Image Adjustment'),
                model: adjustmentList,
                selected: this._backgroundSettings.get_enum('picture-options'),
            });
            backgroundAdjustRow.connect('notify::selected', widget => {
                this._backgroundSettings.set_enum('picture-options', widget.selected);
            });
            backgroundGroup.add(backgroundAdjustRow);
        }
    
        _createSpinButton(value, lower, upper) {
            const spinButton = new Gtk.SpinButton({
                adjustment: new Gtk.Adjustment({
                    lower, upper, step_increment: 1, page_increment: 1, page_size: 0,
                }),
                climb_rate: 1,
                digits: 0,
                numeric: true,
                valign: Gtk.Align.CENTER,
                wrap: true,
                value,
                orientation: Gtk.Orientation.VERTICAL,
                width_request: 40,
            });
            return spinButton;
        }
    }
);
*/

export default class ReminderAlarmClockPreferences extends ExtensionPreferences {
/*
    fillPreferencesWindow(window) {
        const settings = this.getSettings();

        const slideShowPage = new SlideShowPage(settings);
        window.add(slideShowPage);

        const bingPage = new BingPage(settings);
        window.add(bingPage);

        const aboutPage = new AboutPage(settings, this.metadata);
        window.add(aboutPage);

    }
*/
    getPreferencesWidget() {
        const settings = this.getSettings();

        // Create a parent widget that we'll return from this function
        let prefsWidget = new Gtk.Grid({
            margin_start: 36,
            margin_end: 36,
            margin_top: 36,
            margin_bottom: 36,
            column_spacing: 12,
            row_spacing: 12,
            visible: true,
            hexpand: true
        });

        let title = new Gtk.Label({
            label: '<b>' + this.metadata.name + ' ' + _('Extension Preferences') + '</b>',
            halign: Gtk.Align.CENTER,
            hexpand: true,
            use_markup: true,
            visible: true
        });
        prefsWidget.attach(title, 0, 0, 2, 1);


        let dropSecondsLabel = new Gtk.Label({
            label: _('Round to minutes:'),
            halign: Gtk.Align.START,
            visible: true
        });
        prefsWidget.attach(dropSecondsLabel, 0, 1, 1, 1);

        let dropSecondsSwitch = new Gtk.Switch({
            active: settings.get_boolean('drop-seconds'),
            halign: Gtk.Align.END,
            visible: true
        });
        prefsWidget.attach(dropSecondsSwitch, 1, 1, 1, 1);

        settings.bind(
            'drop-seconds',
            dropSecondsSwitch,
            'active',
            Gio.SettingsBindFlags.DEFAULT
        );


        let autoCloseReminderWindowLabel = new Gtk.Label({
            label: _('Auto hide reminder window:'),
            halign: Gtk.Align.START,
            visible: true
        });
        prefsWidget.attach(autoCloseReminderWindowLabel, 0, 2, 1, 1);

        let autoCloseReminderWindowSwitch = new Gtk.Switch({
            active: settings.get_boolean('auto-close-reminder-window'),
            halign: Gtk.Align.END,
            visible: true
        });
        prefsWidget.attach(autoCloseReminderWindowSwitch, 1, 2, 1, 1);

        settings.bind(
            'auto-close-reminder-window',
            autoCloseReminderWindowSwitch,
            'active',
            Gio.SettingsBindFlags.DEFAULT
        );


        let showRemainingTimeInTaskbarLabel = new Gtk.Label({
            label: _('Show remaining time in taskbar:'),
            halign: Gtk.Align.START,
            visible: true
        });
        prefsWidget.attach(showRemainingTimeInTaskbarLabel, 0, 3, 1, 1);

        let showRemainingTimeInTaskbarSwitch = new Gtk.Switch({
            active: settings.get_boolean('show-remaining-time-in-taskbar'),
            halign: Gtk.Align.END,
            visible: true
        });
        prefsWidget.attach(showRemainingTimeInTaskbarSwitch, 1, 3, 1, 1);

        settings.bind(
            'show-remaining-time-in-taskbar',
            showRemainingTimeInTaskbarSwitch,
            'active',
            Gio.SettingsBindFlags.DEFAULT
        );


        let playSoundLabel = new Gtk.Label({
            label: _('Play sound:'),
            halign: Gtk.Align.START,
            visible: true
        });
        prefsWidget.attach(playSoundLabel, 0, 4, 1, 1);

        let playSoundSwitch = new Gtk.Switch({
            active: settings.get_boolean('play-sound'),
            halign: Gtk.Align.END,
            visible: true
        });
        prefsWidget.attach(playSoundSwitch, 1, 4, 1, 1);

        settings.bind(
            'play-sound',
            playSoundSwitch,
            'active',
            Gio.SettingsBindFlags.DEFAULT
        );

        let soundChooser = new Gtk.Button({
            visible: true,
            label: this.soundChooserLabel(),
        });

        soundChooser.connect('clicked', (widget) => {
            let dialog = new Gtk.FileChooserNative({
                action: Gtk.FileChooserAction.OPEN,
                modal: true,
                title: _("Please choose sound file"),
            });
            dialog.set_file(Gio.File.new_for_uri(settings.get_string('sound-file-path')));
            dialog.connect('response', (dialog, response_id) => {
                if(response_id == Gtk.ResponseType.ACCEPT)
                {
                    settings.set_string('sound-file-path', dialog.get_file().get_uri());
                    soundChooser.set_label(this.soundChooserLabel());
                }
            });

            dialog.show();
        });

        prefsWidget.attach(soundChooser, 1, 5, 1, 1);

        playSoundSwitch.connect('state-set', (self) => {
            soundChooser.set_sensitive(self.active);
        });


        let timeRepeatEntry = new Gtk.Entry({
            text: settings.get_string('time-repeat'),
            halign: Gtk.Align.END,
            visible: true,        
            name: 'time-repeat-entry'
        });

        timeRepeatEntry.connect('changed', (self) => {
            if (/^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/.test(self.text)) {
                settings.set_string('time-repeat', self.text);
                self.secondary_icon_name = '';
            } else {
                self.secondary_icon_name = 'dialog-error-symbolic';
            }
        });

        settings.bind(
            'time-repeat',
            timeRepeatEntry,
            'icon-press',
            Gio.SettingsBindFlags.DEFAULT
        );

        let repeatLabel = new Gtk.Label({
            label: _('Repeat every day:'),
            halign: Gtk.Align.START,
            visible: true
        });
        prefsWidget.attach(repeatLabel, 0, 6, 1, 1);

        let repeatSwitch = new Gtk.Switch({
            active: settings.get_boolean('repeat'),
            halign: Gtk.Align.END,
            visible: true
        });
        
        repeatSwitch.connect('state-set', (self) => {
            timeRepeatEntry.set_sensitive(self.active);
        });

        settings.bind(
            'repeat',
            repeatSwitch,
            'active',
            Gio.SettingsBindFlags.DEFAULT
        );

        prefsWidget.attach(repeatSwitch, 1, 6, 1, 1);
        prefsWidget.attach(timeRepeatEntry, 1, 7, 1, 1);


        let presentsLabel = new Gtk.Label({
            label: _('Presents <small>(extension restart needed)</small>:'),
            halign: Gtk.Align.START,
            use_markup: true,
            visible: true
        });
        prefsWidget.attach(presentsLabel, 0, 8, 1, 1);

        let presentsEntry = new Gtk.Entry({
            text: settings.get_string('presents'),
            halign: Gtk.Align.END,
            visible: true
        });
        prefsWidget.attach(presentsEntry, 1, 8, 1, 1);

        settings.bind(
            'presents',
            presentsEntry,
            'text',
            Gio.SettingsBindFlags.DEFAULT
        );


        let showTestNotificationButton = new Gtk.Button({
            label: _('Show test notification'),
            halign: Gtk.Align.CENTER,
            visible: true
        });

        showTestNotificationButton.connect('clicked', () => {
            settings.set_boolean(
                'show-test-notification', !settings.get_boolean(
                    'show-test-notification'));
        });

        prefsWidget.attach(showTestNotificationButton, 0, 9, 2, 1);

        return prefsWidget;
    }

    soundChooserLabel() {
        let file = Gio.File.new_for_uri(this.getSettings().get_string('sound-file-path'))
        let filename = file.get_basename() || "None"
        return `${_('Selected')} "${filename}". ${_('Choose new…')}`;
    }
}
